Graphics3D 800,600,32,2 
 
Global Camera = CreateCamera() 
CameraRange(Camera,0.1,100)
CameraClsColor(Camera,000,000,000)

Global Listener = CreateListener(Camera)

SLight = CreateLight(1)
LightColor(SLight,255,255,255)
PositionEntity(SLight,-1000,1000,-1000)
RotateEntity(SLight,45,-45,0)

AmbientLight(050,050,050)

Global ThingMesh = CreateMesh() 
TPart = CreateCube()
ScaleMesh(TPart,1.0/2,0.1/2,0.1/2)
AddMesh(TPart,ThingMesh)
FreeEntity(TPart)
TPart = CreateCube()
ScaleMesh(TPart,0.1/2,0.1/2,1.0/2)
AddMesh(TPart,ThingMesh)
FreeEntity(TPart)
PositionEntity(ThingMesh,0,0,0,True) 

Global MotorSound = Load3DSound("Motor.wav")
Global MotorChannel
Global MotorSpeed# = 1.1
Global MotorChannelPitch%

PositionEntity(Camera,0,1.65,-3,True) 
PointEntity(Camera,ThingMesh)

Main()

End()

Function Main()

 Repeat

  ;Motor accelerate
  If( KeyDown(200)=1 )
   MotorSpeed = MotorSpeed + 0.01
   If( MotorSpeed > 4.4 )	
    MotorSpeed = 4.4		
   EndIf
  EndIf
		
  ;Motor decelerate
  If( KeyDown(208)=1 )
   MotorSpeed = MotorSpeed - 0.01
   If( MotorSpeed < 1.1 )
	 MotorSpeed = 1.1
   EndIf
  EndIf

  ;turn thing (turned by motor)
  TurnEntity(ThingMesh,0,MotorSpeed*10,0)
	
  ;Motor sound
  MotorChannelPitch = MotorSpeed*10000
  If( MotorChannelPitch < 11000 )
   MotorChannelPitch = 11000
  ElseIf( MotorChannelPitch > 44000 )
   MotorChannelPitch = 44000
  EndIf
  If( Not ChannelPlaying(MotorChannel) )
   MotorChannel = EmitSound(MotorSound,ThingMesh)
   ChannelVolume(MotorChannel,1.0)
  EndIf
  ChannelPitch MotorChannel,MotorChannelPitch

  SetBuffer(BackBuffer())
  RenderWorld()
	
  Text(0,0,"MotorSpeed = "+MotorSpeed)
  Text(0,15,"MotorChannelPitch = "+MotorChannelPitch)
	
  Flip(1)

 Until( KeyDown(1)=1 )

End Function
